#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

#define For(i,a , n)for(ll i = a;i<(ll)n;i++)
#define vec vector
#define all(x) begin(x), end(x)
#define sz(x)(ll)size(x)

template<class A, class B>
pair<A, B> operator+(const pair<A, B>& a, const pair<A, B>& b){
    return {a.first + b.first, a.second + b.second};
}

template<class A, class B>
ostream& operator<<(ostream& os, const pair<A, B>& a){
    return os<<"("<<a.first<<", "<<a.second<<")";
}

template<class A, class B, class C>
basic_ostream<A, B>& operator<<(basic_ostream<A, B>& os, const C& c){
    for(auto itr = begin(c);itr!=end(c);++itr){
        os<<(itr==begin(c)?"":" ")<<*itr;
    }
    return os;
}

template<typename... Args>
void dbg(Args&&... args){
    ((cerr<<args<<"| "),...);
    cerr<<endl;
}

void solve(){

    ll h,w;
    cin >> h >> w;

    //odd/first left, even/second right
    vector<vector<pair<ll,ll>>> coord_side_to_id;
    //0 is goal, 1 is start
    ll next_used_id = 2;
    //get field from id/2
    vector<pair<ll,ll>> id_to_coord;
    id_to_coord.push_back({-1,-1});

    vector<vector<char>> grid(h);
    For(i,0,h){
        string row;
        cin >> row;
        vector<pair<ll,ll>> big_index_row(w);
        For(j,0,w){
            grid[i].push_back(row[j]);
            if(row[j] == '/'){
                big_index_row[j] = {next_used_id,next_used_id+1};
                id_to_coord.push_back({i,j});
                next_used_id += 2;
            }else if(row[j] == '\\'){
                big_index_row[j] = {next_used_id,next_used_id+1};
                id_to_coord.push_back({i,j});
                next_used_id += 2;
            }else if(row[j] == 'S'){
                id_to_coord[0] = {i,j};
            }else{
                big_index_row[j] = {-1,-1};
            }
        }
        coord_side_to_id.push_back(big_index_row);
    }

    vector<vector<pair<ll,ll>>> edges(next_used_id);

    //connect mirror sides
    For(i,2,next_used_id){
        ll other;
        if(i % 2 == 0){
            other = i+1;
        }else{
            other = i-1;
        }
        edges[i].push_back({other,1});
    }

    //connect mirrors
    For(row,0,h){
        //lr
        ll lneigh = 0;
        For(pos,0,w){
            char what = grid[row][pos];
            if(what == '#'){
                lneigh = -1;
            }else if(what == 'S'){
                if(lneigh != -1){
                    edges[1].push_back({lneigh,0});
                }
                lneigh = 1;
            }else if(what == '\\' || what == '/'){
                if(lneigh != -1){
                    edges[coord_side_to_id[row][pos].first].push_back({lneigh,0});
                }
                lneigh = coord_side_to_id[row][pos].second;
            }
        }

        //rl
        ll rneigh = 0;
        For(i,0,w){
            ll pos = w-1-i;
            char what = grid[row][pos];
            if(what == '#'){
                rneigh = -1;
            }else if(what == 'S'){
                if(rneigh != -1){
                    edges[1].push_back({rneigh,0});
                }
                rneigh = 1;
            }else if(what == '\\' || what == '/'){
                if(rneigh != -1){
                    edges[coord_side_to_id[row][pos].second].push_back({rneigh,0});
                }
                rneigh = coord_side_to_id[row][pos].first;
            }
        }
    }

    For(col,0,w){
        //ud
        ll uneigh = 0;
        For(pos,0,h){
            char what = grid[pos][col];
            if(what == '#'){
                uneigh = -1;
            }else if(what == 'S'){
                if(uneigh != -1){
                    edges[1].push_back({uneigh,0});
                }
                uneigh = 1;
            }else if(what == '\\'){
                if(uneigh != -1){
                    edges[coord_side_to_id[pos][col].second].push_back({uneigh,0});
                }
                uneigh = coord_side_to_id[pos][col].first;
            }else if(what == '/'){
                if(uneigh != -1){
                    edges[coord_side_to_id[pos][col].first].push_back({uneigh,0});
                }
                uneigh = coord_side_to_id[pos][col].second;
            }
        }

        //du
        ll dneigh = 0;
        For(i,0,h){
            ll pos = h-1-i;
            char what = grid[pos][col];
            if(what == '#'){
                dneigh = -1;
            }else if(what == 'S'){
                if(dneigh != -1){
                    edges[1].push_back({dneigh,0});
                }
                dneigh = 1;
            }else if(what == '\\'){
                if(dneigh != -1){
                    edges[coord_side_to_id[pos][col].first].push_back({dneigh,0});
                }
                dneigh = coord_side_to_id[pos][col].second;
            }else if(what == '/'){
                if(dneigh != -1){
                    edges[coord_side_to_id[pos][col].second].push_back({dneigh,0});
                }
                dneigh = coord_side_to_id[pos][col].first;
            }
        }
    }

    vector<ll> how_distant_is_id(next_used_id,-1);
    priority_queue<pair<ll,ll>> frontier;
    // distance, and then id
    frontier.push({0,1});
    ll final_node_id = -1;
    while(true){
        if(frontier.empty()){
            break;
        }
        pair<ll,ll> now = frontier.top();
        frontier.pop();
        ll id = now.second;
        if(how_distant_is_id[id] > -1){
            continue;
        }
        how_distant_is_id[id] = now.first;
        For(i,0,edges[id].size()){
            ll neigh = edges[id][i].first;
            ll delta = edges[id][i].second;
            if(neigh == 0){
                if(final_node_id == -1){
                    final_node_id = id;
                }
            }else{
                frontier.push({now.first+delta,neigh});
            }
        }
    }

    if(final_node_id == -1){
        cout << "NO\n";
        return;
    }

    dbg(how_distant_is_id);
    dbg(final_node_id);
    dbg(id_to_coord);

    //now we simulate backwards from the final node, breaching the mirror every time the other side is one lower than ours
    
    pair<ll,ll> pos = id_to_coord[final_node_id/2];
    //we are entering this node at this moment

    vector<pair<ll,pair<ll,ll>>> backwards_commands;




}

int main(){
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    ll t = 1; // cin>>t;
    while(t--)solve();
}